Codeforces 191 C Fools and Roads (树链拆分)

主题链接~~>

做题情绪:做了HDU 5044后就感觉非常easy了。

解题思路:

先树链剖分一下,把树剖分成链,由于最后全是询问,so~能够线性操作。经过树链剖分后,就会形成很多链,可是每条边都有编号,相当于一个数组进行线性操作,这样。如果在 u  ~ v 去都添加 1 。那么能够让 sum [ u ] += 1 ; sum [ v + 1 ] -= 1 ; 这里如果 v 的编号大。

最后的时候仅仅要从后往前遍历一次就能够了。得到全部的结果。明确这点后再加上树链剖分的思想就能够攻克了。

代码:

#include<iostream>
#include<sstream>
#include<map>
#include<cmath>
#include<fstream>
#include<queue>
#include<vector>
#include<sstream>
#include<cstring>
#include<cstdio>
#include<stack>
#include<bitset>
#include<ctime>
#include<string>
#include<cctype>
#include<iomanip>
#include<algorithm>
using namespace std  ;
#define INT __int64
#define L(x)  (x * 2)
#define R(x)  (x * 2 + 1)
const int INF = 0x3f3f3f3f ;
const double esp = 0.0000000001 ;
const double PI = acos(-1.0) ;
const int mod = 1e9 + 7 ;
const int MY = 1400 + 5 ;
const int MX = 100000 + 5 ;
int n ,num ,idx ,m ;
int head[MX] ,sum[MX] ,ans[MX] ,P[MX] ,ti[MX] ,dep[MX] ,top[MX] ,siz[MX] ,son[MX] ,father[MX] ;
struct NODE
{
    int u ,v ;
}e[MX] ;
struct node
{
    int v ,next ;
}E[MX*2] ;
void addedge(int u ,int v)
{
    E[num].v = v ; E[num].next = head[u] ; head[u] = num++ ;
    E[num].v = u ; E[num].next = head[v] ; head[v] = num++ ;
}
void dfs_find(int u ,int fa)
{
    dep[u] = dep[fa] + 1 ;
    siz[u] = 1 ;
    son[u] = 0 ;
    father[u] = fa ;
    for(int i = head[u] ;i != -1 ;i = E[i].next)
    {
        int v = E[i].v ;
        if(v == fa)  continue ;
        dfs_find(v ,u) ;
        siz[u] += siz[v] ;
        if(siz[son[u]] < siz[v])  son[u] = v ;
    }
}
void dfs_time(int u ,int fa)
{
    ti[u] = idx++ ;
    top[u] = fa ;
    if(son[u])  dfs_time(son[u] ,top[u]) ;
    for(int i = head[u] ;i != -1 ;i = E[i].next)
    {
        int v = E[i].v ;
        if(v == father[u] || v == son[u])   continue ;
        dfs_time(v ,v) ;
    }
}
void LCA(int u ,int v)
{
    while(top[u] != top[v])
    {
        if(dep[top[u]] < dep[top[v]])
              swap(u ,v) ;
        sum[ti[u]+1] -= 1 ;
        sum[ti[top[u]]] += 1 ;
        u = father[top[u]] ;
    }
    if(dep[u] > dep[v])
       swap(u ,v) ;
    if(u != v)
    {
        sum[ti[son[u]]] += 1 ;
        sum[ti[v]+1] -= 1 ;
    }
}
int main()
{
    //freopen("input.txt" ,"r" ,stdin) ;
    int u ,v ;
    while(~scanf("%d" ,&n))
    {
        num = 0 ;
        memset(head ,-1 ,sizeof(head)) ;
        memset(sum ,0 ,sizeof(sum)) ;
        for(int i = 1 ;i < n ; ++i)
        {
            scanf("%d%d" ,&e[i].u ,&e[i].v) ;
            addedge(e[i].u ,e[i].v) ;
        }
        dep[1] = siz[0] = 0 ;
        dfs_find(1 ,1) ;
        idx = 1 ;
        dfs_time(1 ,1) ;
        scanf("%d" ,&m) ;
        for(int i = 0 ;i < m ; ++i)
        {
           scanf("%d%d" ,&u ,&v) ;
           LCA(u ,v) ;
        }
        for(int i = 1 ;i <= n ; ++i) // 第几条边
        {
            if(dep[e[i].u] < dep[e[i].v])
                swap(e[i].u ,e[i].v) ;
            P[ti[e[i].u]] = i ;
        }
        for(int i = 1 ;i <= n ; ++i)  // 在剖分中的编号边的编号
        {
            sum[i] += sum[i-1] ;
            ans[P[i]] = sum[i] ;
        }
        printf("%d" ,ans[1]) ;
        for(int i = 2 ;i < n ; ++i)
           printf(" %d" ,ans[i]) ;
        puts("") ;
    }
    return 0 ;
}

版权声明:本文博客原创文章,博客,未经同意,不得转载。

时间: 2024-10-07 06:58:42

Codeforces 191 C Fools and Roads (树链拆分)的相关文章

Codeforces 191 C Fools and Roads (树链剖分)

题目链接~~> 做题感悟:这题在做了HDU 5044后就感觉很简单了. 解题思路: 先树链剖分一下,把树剖分成链,因为最后全是询问,so~可以线性操作.经过树链剖分后,就会形成许多链,但是每条边都有编号,相当于一个数组进行线性操作,这样,如果在 u  ~ v 去都增加 1 ,那么可以让 sum [ u ] += 1 ; sum [ v + 1 ] -= 1 ; 这里假设 v 的编号大.最后的时候只要从后往前遍历一次就可以了,得到所有的结果.明白这点后再加上树链剖分的思想就可以解决了. 代码: #

Codeforces 191C Fools and Roads(树链剖分)

题目链接:Codeforces 191C Fools and Roads 题目大意:给定一个N节点的数,然后有M次操作,每次从u移动到v,问说每条边被移动过的次数. 解题思路:树链剖分维护边,用一个数组标记即可,不需要用线段树. #include <cstdio> #include <cstring> #include <algorithm> using namespace std; const int maxn = 1e5 + 5; int N, Q, ne, fir

Codeforces Round #425 (Div. 2) D 树链剖分 + 树状数组维护区间

一看就知道 可以LCA判断做 也可以树链剖分拿头暴力 然而快速读入和线段树维护区间会T70 于是只能LCA? 线段树的常数不小 于是需要另外一种办法来进行区间加减和查询区间和 就是使用树状数组 这个题的代码 #include<iostream> #include<cstdio> #include<cmath> #include<algorithm> #include<vector> #include<cstring> using na

BZOJ 3589 动态树 树链拆分+纳入和排除定理

标题效果:鉴于一棵树.每个节点有一个右值,所有节点正确启动值他们是0.有两种操作模式,0 x y代表x右所有点的子树的根值添加y. 1 k a1 b1 a2 b2 --ak bk代表质疑. 共同拥有者k边缘( k <= 5),这些边保证是一个点到根节点的路径上的一段. 问这些路径段上的点的权值和是多少,可能有多条路径重叠的情况. 思路:子树改动,区间查询,非常明显用树链剖分解决,树链剖分维护一个size域.那么x的子树的范围就是pos[x]到pos[x] + size[x] - 1这一段上.能够

HYSBZ 2243 染色 (树链拆分)

主题链接~~> 做题情绪:这题思路好想.调试代码调试了好久.第一次写线段树区间合并. 解题思路: 树链剖分 + 线段树区间合并 线段树的端点记录左右区间的颜色.颜色数目.合并的时候就用区间合并的思想. 还要注意一点.在由一条链转到还有一条链的时候要推断当前节点是否与父亲节点是否同一种颜色. 代码: #include<iostream> #include<sstream> #include<map> #include<cmath> #include<

hdu 4912 Paths on the tree(树链拆分+贪婪)

题目链接:hdu 4912 Paths on the tree 题目大意:给定一棵树,和若干个通道.要求尽量选出多的通道,而且两两通道不想交. 解题思路:用树链剖分求LCA,然后依据通道两端节点的LCA深度排序,从深度最大优先选.推断两个节点均没被标 记即为可选通道. 每次选完通道.将该通道LCA下面点所有标记. #pragma comment(linker, "/STACK:1024000000,1024000000") #include <cstdio> #includ

poj 3237 Tree(树链拆分)

题目链接:poj 3237 Tree 题目大意:给定一棵树,三种操作: CHANGE i v:将i节点权值变为v NEGATE a b:将ab路径上全部节点的权值变为相反数 QUERY a b:查询ab路径上节点权值的最大值. 解题思路:树链剖分.然后用线段树维护节点权值,成端更新查询. #include <cstdio> #include <cstring> #include <algorithm> using namespace std; const int max

URAL 1553. Caves and Tunnels 树链拆分

一颗树 每次出发点右键值是0 2操作模式1.第一i右键点值添加x 2.乞讨u至v在这条路上右上方值 树为主的连锁分裂称号 #include <cstdio> #include <cstring> #include <algorithm> using namespace std; const int maxn = 100010; struct edge { int v, next; }e[maxn*2]; int first[maxn], cnt; void AddEdg

CF 191C Fools and Roads lca 或者 树链剖分

They say that Berland has exactly two problems, fools and roads. Besides, Berland has n cities, populated by the fools and connected by the roads. All Berland roads are bidirectional. As there are many fools in Berland, between each pair of cities th